########################################################################
# Copyright (C) 1988,1989,1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../data/minisql.4gs/select.4gl  1.3  Delta: 4/17/90
########################################################################

globals "globals.4gl"

define
    data array[150] of char(75)

#####################################################################
function sql_select()
#####################################################################
# This function takes the sql_str (that contains a select statment)
# and outputs the data to stdout.
#
    define
       n smallint,         # counter
       m smallint,         # counter
       c char(1),          # current character
       cur_col  smallint,  # current column
       num_cols smallint   # number of columns

    prepare run_cmd from sql_str
    declare cur cursor for run_cmd
    open cur

    let num_cols = null
    for n = 1 to 150
        let data[n] = "!@#~"
    end for

    foreach cur into
        data[ 1], data[ 2], data[ 3], data[ 4], data[ 5],
        data[ 6], data[ 7], data[ 8], data[ 9], data[10],
        data[11], data[12], data[13], data[14], data[15],
        data[16], data[17], data[18], data[19], data[20],
        data[21], data[22], data[23], data[24], data[25],
        data[26], data[27], data[28], data[29], data[30],
        data[31], data[32], data[33], data[34], data[35],
        data[36], data[37], data[38], data[39], data[40],
        data[41], data[42], data[43], data[44], data[45],
        data[46], data[47], data[48], data[49], data[50],
        data[51], data[52], data[53], data[54], data[55],
        data[56], data[57], data[58], data[59], data[60],
        data[61], data[62], data[63], data[64], data[65],
        data[66], data[67], data[68], data[69], data[70],
        data[71], data[72], data[73], data[74], data[75],
        data[76], data[77], data[78], data[79], data[80],
        data[81], data[82], data[83], data[84], data[85],
        data[86], data[87], data[88], data[89], data[90],
        data[91], data[92], data[93], data[94], data[95],
        data[96], data[97], data[98], data[99], data[100],
        data[101], data[102], data[103], data[104], data[105],
        data[106], data[107], data[108], data[109], data[110],
        data[111], data[112], data[113], data[114], data[115],
        data[116], data[117], data[118], data[119], data[120],
        data[121], data[122], data[123], data[124], data[125],
        data[126], data[127], data[128], data[129], data[130],
        data[131], data[132], data[133], data[134], data[135],
        data[136], data[137], data[138], data[139], data[140],
        data[141], data[142], data[143], data[144], data[145],
        data[146], data[147], data[148], data[149], data[150] 

        # gracefully exit if the interrupt is pressed
        if int_flag != 0 then exit program (1) end if

        # determine the number of columns selected
        if num_cols is null
        then
            for n = 150 to 1 step -1
              if data[n] = "!@#~"
              then else
                  let num_cols = n
                  exit for
              end if
            end for
        end if

        # build the output line into sql_str
        let sql_str = " "
        let n = 1
        for cur_col = 1 to num_cols
            # go through each character of the data
            # to make sure there are no "|" characters.
            # escape it if there is one found.
            for m = 1 to length(data[cur_col])
                let c = data[cur_col][m,m]
                if c = "|"
                then
                    let sql_str[n,n] = bkslsh
                    let n = n + 1
                end if
                let sql_str[n,n] = c
                let n = n + 1
            end for  # all characters in the column
            if num_cols > 1
              then let sql_str[n,n] = "|"  # insert the column seperator
            end if
            let n = n + 1
        end for      # all columns in the row

        # display the data to the screen
        display sql_str clipped
    end foreach

end function
# sql_select()
