########################################################################
# Copyright (C) 1988,1989,1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../data/minisql.4gs/sqlfile.4gl  1.4  Delta: 9/20/90
########################################################################

globals "globals.4gl"

########################################################################
function get_sqlfile()
########################################################################
#  this function loads the sql file into the temp table
#
    define
        counter smallint

    let counter = 0
    whenever error continue
    while true
        create table minisql (data char(255))
        if sqlca.sqlcode = 0
        then
            grant all on minisql to public
            exit while
        end if
        sleep 1
        let counter = counter + 1
        if counter > 5
        then
            display sqlca.sqlcode using "SQL error number: -<<<<<<<",
                    " occurred on the previous command."
            display ""
            exit program(1)
        end if
        if counter > 4 then drop table minisql end if
    end while
    whenever error stop

    # output the dbload format to load.com
    start report loadit
    output to report loadit (sql_file)
    finish report loadit

    # load data into database...
    let sql_str =
        "dbload -d ",db_name clipped,
                    " -n 2000 -c dbload.cmd -l errfile > /dev/null 2>&1"
    run sql_str
    let sql_str = "rm -f dbload.cmd errfile"
    run sql_str

    # move data to a temp table just in case we bomb...
    # only load non-commented non-blank lines
    select minisql.data from minisql
      where minisql.data is not null and
            minisql.data not matches "#*"
      into temp tmp_table

    # so long (short lived table)...
    whenever error continue
    drop table minisql
    whenever error stop


end function
# get_sqlfile()
