########################################################################
# Copyright (C) 1988,1989,1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../data/minisql.4gs/load.4gl  1.3  Delta: 4/30/90
########################################################################

globals "globals.4gl"

########################################################################
function load_tables()
########################################################################
#
    define
        scratch char(255),    # scratch string storage
        n_cols smallint,      # number of columns in this table
        x smallint,           # working number
        n smallint            # working number


    declare load_curs cursor for
        select data from tmp_table

    foreach load_curs into scratch
        if  scratch[1,12] = "create table"
         or scratch[1,14] = "define data in"
        then
            let x = 13
            while scratch[x,x] != " "
                let x = x + 1
            end while
            while scratch[x,x] = " "
                let x = x + 1
            end while
            let n = x
            while scratch[n,n] != " "
                let n = n + 1
            end while
            let n = n - 1
            let sql_str = scratch[x,n]

            # get number of columns
            select ncols into n_cols from systables
              where tabname = sql_str

            display "Writing dbload script for ",sql_str clipped

            start report oneline to "dbload.cmd"
            let scratch = "file ", quote, sql_str clipped, ".unl",
                quote, " delimiter ",quote, "|",
                quote, n_cols using " <<<", ";"
            output to report oneline(scratch)

            let scratch = "insert into ",sql_str clipped, " ;"
            output to report oneline(scratch)
            finish report oneline

            # load data into database...
            let sql_str =
                "mv dbload.cmd ", data_dir clipped,
                "; cd ", data_dir clipped,
                "; dbload -d ",db_name clipped,
                " -n 10000 -c dbload.cmd -l errfile",
                "; rm -f dbload.cmd errfile"
            run sql_str

        end if
    end foreach

end function
# load_tables()
