##############################################################################
# Copyright 1988 Fourgen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../data/minisql.4gs/minisql.4gl  1.1  Last Delta: 10/25/88
##############################################################################

globals "globals.4gl"

###########################################################################
function minisql()
###########################################################################
#  The purpose of this function is to take the text in a temp
#  table & run it.
#
    define
        scratch char(255),    # scratch string storage
        execflag smallint,    # execute this time ?
        x smallint,           # working number
        n smallint            # working number

    declare work_curs cursor for
        select data from tmp_table

    # make sure we have a clean sql_str to start with
    let sql_str = ""

    foreach work_curs into scratch
        let n = length(scratch)
        let x = 1
        while scratch[x,x] = " "
            let x = x + 1
        end while
        if scratch[n,n] = ";"
        then
            let n = n - 1
            let execflag = true
        else
            let execflag = false
        end if

        if sql_str is null
        then
            let sql_str = scratch[x,n]
        else
            let sql_str = sql_str clipped, " ", scratch[x,n]
        end if

        if execflag
        then
            call sql_exec()
        end if
    end foreach

    if sql_str is not null
    then
        call sql_exec()
    end if

    return
end function
# minisql()
